/* puzzle: mixing types */
#include <stdio.h>

int main() {
    double d; float f; long l; int i;
    
    i = d = .7 + 10/3;
    printf("i=%d, d=%.8lf\n", i, d);

    i = l = f = d = 100/3;
    printf("i=%d, l=%ld, f=%.8f, d=%.8lf\n", i, l, f, d);

    i = l = f = d = (double) 100/3;
    printf("i=%d, l=%ld, f=%.30lf, d=%.60lf\n", i, l, f, d);

    i = l = f = d = 100/3.0;
    printf("i=%d, l=%ld, f=%.30lf, d=%.60lf\n", i, l, f, d);

    l = 2; f = 3.2;
    d = (i=f/l)*2;
    printf("i=%d, d=%.12lf\n", i, d);

    i = (d=f/l)*2;
    printf("i=%d, d=%.12lf\n", i, d);
    printf("%d\n", (d*l == f));

    return 0;
}
