#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define FILENAME 64

void printUsage() {
  printf("-x %-10s%s\n", "", "simple switch option");
  printf("-n %-10s%s\n", "N", "an integer number");
  printf("-f %-10s%s\n", "file.dat", "input data file");
  printf("\n");
}

int main (int argc, char *argv[]) {

  char c, progname[FILENAME]="";

  /* program interanl options */
  int number = 0, myswitch = 0;
  char userfile[FILENAME]="";

  strncpy(progname, argv[0], FILENAME);

  while (--argc > 0 && (*++argv)[0] == '-')
    while ( (c = *++argv[0]) )
      switch (c) {
      case 'x':
        myswitch = 1;
        break;
      case 'n':
        --argc;
        number = atoi(*++argv);
        break;
      case 'f':
        --argc;
        strncpy(userfile, *++argv, FILENAME);
        break;
      default:
        printf("%s: illegal option %c\n", progname, c);
        printUsage();
        argc = 0;
        break;
      }

  if (argc != 1) {
    printf("argc = %d\n", argc);
    printUsage();
  }

  return 0;
}
