#ifndef LINEAR_ALGEBRA_H
#define LINEAR_ALGEBRA_H

void printMatrix(int lda, int ldb, const double *a);
void printVector(int lda, const double *v);
double trace( int ldb, const double *a);
void dmatrix_vector(int lda, int ldb, 
    const double *a, const double *v, double *c);
void dmatrix_matrix(int lda, int ldb, int ldc, 
    const double *a, const double *b, double *c); 

#endif // LINEAR_ALGEBRA_H
